<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">

<html lang="en">
<head>

<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">

<meta name="generator" content="PHPDoctor 2RC4 (http://peej.github.com/phpdoctor/)">
<meta name="when" content="Fri, 15 Apr 2011 16:43:07 +0000">

<link rel="stylesheet" type="text/css" href="../../stylesheet.css">
<link rel="start" href="../../overview-summary.html">

<title>classes/tag.php (PHPDoctor)</title>

</head>
<body id="file" onload="parent.document.title=document.title;">

<div class="header">
<h1>PHPDoctor</h1>
<ul>
<li><a href="../../overview-summary.html">Overview</a></li>
<li>Package</li><li>Class</li><li>Tree</li><li><a href="../../overview-files.html">Files</a></li>
<li><a href="../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../todo-list.html">Todo</a></li>
<li><a href="../../index-all.html">Index</a></li>
</ul>
</div>

<div class="small_links">
<a href="../../index.html" target="_top">Frames</a>
<a href="../../source/classes/tag.php.html" target="_top">No frames</a>
</div>
<hr>

<h1>classes/tag.php</h1>
<hr>

<a name="line1"></a><pre><?php
<a name="line2"></a>/*
<a name="line3"></a>PHPDoctor: The PHP Documentation Creator
<a name="line4"></a>Copyright (C) 2004 Paul James <paul@peej.co.uk>
<a name="line5"></a>
<a name="line6"></a>This program is free software; you can redistribute it and/or modify
<a name="line7"></a>it under the terms of the GNU General Public License as published by
<a name="line8"></a>the Free Software Foundation; either version 2 of the License, or
<a name="line9"></a>(at your option) any later version.
<a name="line10"></a>
<a name="line11"></a>This program is distributed in the hope that it will be useful,
<a name="line12"></a>but WITHOUT ANY WARRANTY; without even the implied warranty of
<a name="line13"></a>MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
<a name="line14"></a>GNU General Public License for more details.
<a name="line15"></a>
<a name="line16"></a>You should have received a copy of the GNU General Public License
<a name="line17"></a>along with this program; if not, write to the Free Software
<a name="line18"></a>Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
<a name="line19"></a>*/
<a name="line20"></a>
<a name="line21"></a>/** Represents a documentation tag, e.g. @since, @author, @version. Given a tag
<a name="line22"></a> * (e.g. "@since 1.2"), holds tag name (e.g. "@since") and tag text (e.g.
<a name="line23"></a> * "1.2"). Tags with structure or which require special processing are handled
<a name="line24"></a> * by subclasses.
<a name="line25"></a> *
<a name="line26"></a> * @package PHPDoctor\Tags
<a name="line27"></a> */
<a name="line28"></a>class Tag
<a name="line29"></a>{
<a name="line30"></a>
<a name="line31"></a>	/** The name of the tag.
<a name="line32"></a>	 *
<a name="line33"></a>	 * @var str
<a name="line34"></a>	 */
<a name="line35"></a>	var $_name = NULL;
<a name="line36"></a>	
<a name="line37"></a>	/** The value of the tag as raw data, without any text processing applied.
<a name="line38"></a>	 *
<a name="line39"></a>	 * @var str
<a name="line40"></a>	 */
<a name="line41"></a>	var $_text = NULL;
<a name="line42"></a>		
<a name="line43"></a>	/** Reference to the root element.
<a name="line44"></a>	 *
<a name="line45"></a>	 * @var rootDoc
<a name="line46"></a>	 */
<a name="line47"></a>	var $_root = NULL;
<a name="line48"></a>
<a name="line49"></a>	/** Reference to the elements parent.
<a name="line50"></a>	 *
<a name="line51"></a>	 * @var programElementDoc
<a name="line52"></a>	 */
<a name="line53"></a>	var $_parent = NULL;
<a name="line54"></a>
<a name="line55"></a>	/**
<a name="line56"></a>	 * Constructor
<a name="line57"></a>	 *
<a name="line58"></a>	 * @param str name The name of the tag (including @)
<a name="line59"></a>	 * @param str text The contents of the tag
<a name="line60"></a>	 * @param RootDoc root The root object
<a name="line61"></a>	 */
<a name="line62"></a>	function tag($name, $text, &$root)
<a name="line63"></a>    {
<a name="line64"></a>		$this->_name = $name;
<a name="line65"></a>		$this->_root =& $root;
<a name="line66"></a>		$this->_text = $text;
<a name="line67"></a>	}
<a name="line68"></a>
<a name="line69"></a>	/** Get name of this tag.
<a name="line70"></a>	 *
<a name="line71"></a>	 * @return str
<a name="line72"></a>	 */
<a name="line73"></a>	function name()
<a name="line74"></a>    {
<a name="line75"></a>		return $this->_name;
<a name="line76"></a>	}
<a name="line77"></a>
<a name="line78"></a>	/** Get display name of this tag.
<a name="line79"></a>	 *
<a name="line80"></a>	 * @return str
<a name="line81"></a>	 */
<a name="line82"></a>	function displayName()
<a name="line83"></a>    {
<a name="line84"></a>		return ucfirst(substr($this->_name, 1));
<a name="line85"></a>	}
<a name="line86"></a>	
<a name="line87"></a>	/** Get the value of the tag as raw data, without any text processing applied.
<a name="line88"></a>	 *
<a name="line89"></a>	 * @param Doclet doclet
<a name="line90"></a>	 * @return str
<a name="line91"></a>	 */
<a name="line92"></a>	function text($doclet)
<a name="line93"></a>    {
<a name="line94"></a>		return $this->_text;
<a name="line95"></a>	}
<a name="line96"></a>	
<a name="line97"></a>	/** Set this tags parent
<a name="line98"></a>	 *
<a name="line99"></a>	 * @param ProgramElementDoc element The parent element
<a name="line100"></a>	 */
<a name="line101"></a>	function setParent(&$element)
<a name="line102"></a>    {
<a name="line103"></a>		$this->_parent =& $element;
<a name="line104"></a>	}
<a name="line105"></a>	
<a name="line106"></a>	/**
<a name="line107"></a>	 * For documentation comment with embedded @link tags, return the array of
<a name="line108"></a>	 * tags. Within a comment string "This is an example of inline tags for a
<a name="line109"></a>	 * documentaion comment {@link Doc commentlabel}", where inside the inner
<a name="line110"></a>	 * braces, the first "Doc" carries exactly the same syntax as a SeeTag and
<a name="line111"></a>	 * the second "commentlabel" is label for the HTML link, will return an array
<a name="line112"></a>	 * of tags with first element as tag with comment text "This is an example of
<a name="line113"></a>	 * inline tags for a documentation comment" and second element as SeeTag with
<a name="line114"></a>	 * referenced class as "Doc" and the label for the HTML link as
<a name="line115"></a>	 * "commentlabel".
<a name="line116"></a>	 *
<a name="line117"></a>	 * @return Tag[] Array of tags with inline tags.
<a name="line118"></a>	 * @todo This method does not act as described but should be altered to do so
<a name="line119"></a>	 */
<a name="line120"></a>	function &inlineTags($formatter)
<a name="line121"></a>    {
<a name="line122"></a>		return $this->_getInlineTags($this->text($formatter));
<a name="line123"></a>	}
<a name="line124"></a>	
<a name="line125"></a>	/**
<a name="line126"></a>	 * Return the first sentence of the comment as tags. Includes inline tags
<a name="line127"></a>	 * (i.e. {@link reference} tags) but not regular tags. Each section of plain
<a name="line128"></a>	 * text is represented as a Tag of kind "Text". Inline tags are represented
<a name="line129"></a>	 * as a SeeTag of kind "link". The sentence ends at the first period that is
<a name="line130"></a>	 * followed by a space, tab, or a line terminator, at the first tagline, or
<a name="line131"></a>	 * at closing of a HTML block element (<p> <h1> <h2> <h3> <h4> <h5> <h6> <hr>
<a name="line132"></a>	 * <pre>).
<a name="line133"></a>	 *
<a name="line134"></a>	 * If PEAR compatibility mode is on, the first double line break also ends
<a name="line135"></a>	 * the first sentence. PEAR documentation advocates ommiting the period from
<a name="line136"></a>	 * the first sentence.
<a name="line137"></a>	 *
<a name="line138"></a>	 * @return Tag[] An array of Tags representing the first sentence of the
<a name="line139"></a>	 * comment
<a name="line140"></a>	 * @todo This method does not act as described but should be altered to do so
<a name="line141"></a>	 */
<a name="line142"></a>	function &firstSentenceTags($formatter)
<a name="line143"></a>    {
<a name="line144"></a>		$phpdoctor = $this->_root->phpdoctor();
<a name="line145"></a>		$matches = array();
<a name="line146"></a>		
<a name="line147"></a>		if ($phpdoctor->getOption('pearCompat')) {
<a name="line148"></a>			$expression = '/^(.+)(?:\n\n|\.( |\t|\n|<\/p>|<\/?h[1-6]>|<hr))/sU';
<a name="line149"></a>			if (preg_match($expression, $this->text($formatter), $matches)) {
<a name="line150"></a>				if (isset($matches[2])) {
<a name="line151"></a>					$return =& $this->_getInlineTags($matches[1].'.'.$matches[2]);
<a name="line152"></a>				} else {
<a name="line153"></a>					$return =& $this->_getInlineTags($matches[1].'.');
<a name="line154"></a>				}
<a name="line155"></a>			} else {
<a name="line156"></a>				$return =& $this->_getInlineTags($this->text($formatter).'.');
<a name="line157"></a>			}
<a name="line158"></a>		} else {
<a name="line159"></a>		    $expression = '/^(.+)(\.(?: |\t|\n|<\/p>|<\/?h[1-6]>|<hr)|$)/sU';
<a name="line160"></a>			if (preg_match($expression, $this->text($formatter), $matches)) {
<a name="line161"></a>				$return =& $this->_getInlineTags($matches[1].$matches[2]);
<a name="line162"></a>			} else {
<a name="line163"></a>				$return = array(&$this);
<a name="line164"></a>			}
<a name="line165"></a>		}
<a name="line166"></a>		return $return;
<a name="line167"></a>	}
<a name="line168"></a>	
<a name="line169"></a>	/**
<a name="line170"></a>	 * Parse out inline tags from within a text string
<a name="line171"></a>	 *
<a name="line172"></a>	 * @param str text
<a name="line173"></a>	 * @return Tag[]
<a name="line174"></a>	 */
<a name="line175"></a>	function &_getInlineTags($text)
<a name="line176"></a>    {
<a name="line177"></a>        $return = NULL;
<a name="line178"></a>		$tagStrings = preg_split('/{(@.+)}/sU', $text, -1, PREG_SPLIT_DELIM_CAPTURE);
<a name="line179"></a>		if ($tagStrings) {
<a name="line180"></a>			$inlineTags = NULL;
<a name="line181"></a>			$phpdoctor =& $this->_root->phpdoctor();
<a name="line182"></a>			foreach ($tagStrings as $tag) {
<a name="line183"></a>			    if (substr($tag, 0, 1) == '@') {
<a name="line184"></a>					$pos = strpos($tag, ' ');
<a name="line185"></a>					if ($pos !== FALSE) {
<a name="line186"></a>						$name = trim(substr($tag, 0, $pos));
<a name="line187"></a>						$text = trim(substr($tag, $pos + 1));
<a name="line188"></a>					} else {
<a name="line189"></a>						$name = $tag;
<a name="line190"></a>						$text = NULL;
<a name="line191"></a>					}
<a name="line192"></a>				} else {
<a name="line193"></a>					$name = '@text';
<a name="line194"></a>					$text = $tag;
<a name="line195"></a>				}
<a name="line196"></a>				$data = NULL;
<a name="line197"></a>				$inlineTag =& $phpdoctor->createTag($name, $text, $data, $this->_root);
<a name="line198"></a>				$inlineTag->setParent($this->_parent);
<a name="line199"></a>				$inlineTags[] = $inlineTag;
<a name="line200"></a>			}
<a name="line201"></a>			$return =& $inlineTags;
<a name="line202"></a>		}
<a name="line203"></a>		return $return;
<a name="line204"></a>	}
<a name="line205"></a>
<a name="line206"></a>	/** Return true if this Taglet is used in constructor documentation.
<a name="line207"></a>     *
<a name="line208"></a>     * @return bool
<a name="line209"></a>     */
<a name="line210"></a>	function inConstructor()
<a name="line211"></a>    {
<a name="line212"></a>		return TRUE;
<a name="line213"></a>	}
<a name="line214"></a>
<a name="line215"></a>	/** Return true if this Taglet is used in field documentation.
<a name="line216"></a>     *
<a name="line217"></a>     * @return bool
<a name="line218"></a>     */
<a name="line219"></a>	function inField()
<a name="line220"></a>    {
<a name="line221"></a>		return TRUE;
<a name="line222"></a>	}
<a name="line223"></a>
<a name="line224"></a>	/** Return true if this Taglet is used in method documentation.          
<a name="line225"></a>     *
<a name="line226"></a>     * @return bool
<a name="line227"></a>     */
<a name="line228"></a>	function inMethod()
<a name="line229"></a>    {
<a name="line230"></a>		return TRUE;
<a name="line231"></a>	}
<a name="line232"></a>
<a name="line233"></a>	/** Return true if this Taglet is used in overview documentation.
<a name="line234"></a>     *
<a name="line235"></a>     * @return bool
<a name="line236"></a>     */
<a name="line237"></a>	function inOverview()
<a name="line238"></a>    {
<a name="line239"></a>		return TRUE;
<a name="line240"></a>	}
<a name="line241"></a>
<a name="line242"></a>	/** Return true if this Taglet is used in package documentation.
<a name="line243"></a>     *
<a name="line244"></a>     * @return bool
<a name="line245"></a>     */
<a name="line246"></a>	function inPackage()
<a name="line247"></a>    {
<a name="line248"></a>		return TRUE;
<a name="line249"></a>	}
<a name="line250"></a>
<a name="line251"></a>	/** Return true if this Taglet is used in class or interface documentation.
<a name="line252"></a>     *
<a name="line253"></a>     * @return bool
<a name="line254"></a>     */
<a name="line255"></a>	function inType()
<a name="line256"></a>    {
<a name="line257"></a>		return TRUE;
<a name="line258"></a>	}
<a name="line259"></a>
<a name="line260"></a>	/** Return true if this Taglet is an inline tag.
<a name="line261"></a>     *
<a name="line262"></a>     * @return bool
<a name="line263"></a>     */
<a name="line264"></a>	function isInlineTag()
<a name="line265"></a>    {
<a name="line266"></a>		return FALSE;
<a name="line267"></a>	}
<a name="line268"></a>	
<a name="line269"></a>	/** Return true if this Taglet should be outputted even if it has no text content.
<a name="line270"></a>     *
<a name="line271"></a>     * @return bool
<a name="line272"></a>     */
<a name="line273"></a>	function displayEmpty()
<a name="line274"></a>    {
<a name="line275"></a>		return TRUE;
<a name="line276"></a>	}
<a name="line277"></a>
<a name="line278"></a>}
<a name="line279"></a>
<a name="line280"></a>?>
<a name="line281"></a></pre>
<div class="header">
<h1>PHPDoctor</h1>
<ul>
<li><a href="../../overview-summary.html">Overview</a></li>
<li>Package</li><li>Class</li><li>Tree</li><li><a href="../../overview-files.html">Files</a></li>
<li><a href="../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../todo-list.html">Todo</a></li>
<li><a href="../../index-all.html">Index</a></li>
</ul>
</div>

<div class="small_links">
<a href="../../index.html" target="_top">Frames</a>
<a href="../../source/classes/tag.php.html" target="_top">No frames</a>
</div>
<hr>

<p id="footer">This document was generated by <a href="http://peej.github.com/phpdoctor/">PHPDoctor: The PHP Documentation Creator</a></p>

</body>

</html>